package gregapi.fluid;

import static gregapi.data.CS.RES_PATH_BLOCK;
import gregapi.GT_API;
import gregapi.util.UT;
import net.minecraftforge.fluids.Fluid;

public class FluidGT extends Fluid implements Runnable {
	private final short[] mRGBa;
	
	public final String mTextureName;
	
	public FluidGT(String aName, String aTextureName, short[] aRGBa, long aTemperatureK) {
		super(aName);
		mRGBa = aRGBa;
		mTextureName = aTextureName;
		setTemperature(UT.Code.bindInt(aTemperatureK));
		if (GT_API.sBlockIconload != null) GT_API.sBlockIconload.add(this);
	}
	
    @Override
	public int getColor() {
        return UT.Code.getRGBInt(mRGBa);
    }
    
	@Override
	public void run() {
		setIcons(GT_API.sBlockIcons.registerIcon(RES_PATH_BLOCK + "fluids/fluid." + mTextureName));
	}
}