package gregapi.recipes.maps;

import static gregapi.data.CS.*;
import gregapi.code.ItemStackContainer;
import gregapi.code.ItemStackMap;
import gregapi.data.CS.ItemsGT;
import gregapi.data.IL;
import gregapi.random.IHasWorldAndCoords;
import gregapi.recipes.Recipe;
import gregapi.recipes.Recipe.RecipeMap;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.Collection;

import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fluids.FluidStack;

/**
 * @author Gregorius Techneticies
 */
public class RecipeMapScannerVisuals extends RecipeMap {
	public RecipeMapScannerVisuals(Collection<Recipe> aRecipeList, String aUnlocalizedName, String aNameLocal, String aNameNEI, long aProgressBarDirection, long aProgressBarAmount, String aNEIGUIPath, long aInputItemsCount, long aOutputItemsCount, long aMinimalInputItems, long aInputFluidCount, long aOutputFluidCount, long aMinimalInputFluids, long aMinimalInputs, long aPower, String aNEISpecialValuePre, long aNEISpecialValueMultiplier, String aNEISpecialValuePost, boolean aShowVoltageAmperageInNEI, boolean aNEIAllowed, boolean aConfigAllowed, boolean aNeedsOutputs) {
		super(aRecipeList, aUnlocalizedName, aNameLocal, aNameNEI, aProgressBarDirection, aProgressBarAmount, aNEIGUIPath, aInputItemsCount, aOutputItemsCount, aMinimalInputItems, aInputFluidCount, aOutputFluidCount, aMinimalInputFluids, aMinimalInputs, aPower, aNEISpecialValuePre, aNEISpecialValueMultiplier, aNEISpecialValuePost, aShowVoltageAmperageInNEI, aNEIAllowed, aConfigAllowed, aNeedsOutputs);
		mMappings.put(new ItemStackContainer(Items.flint_and_steel, 1, W), UT.Stacks.make(Blocks.fire, 1, 0));
		mMappings.put(new ItemStackContainer(Items.reeds, 1, W), UT.Stacks.make(Blocks.reeds, 1, 0));
		mMappings.put(new ItemStackContainer(Items.snowball, 1, W), UT.Stacks.make(Blocks.snow, 1, 0));
		mMappings.put(new ItemStackContainer(Items.wheat_seeds, 1, W), UT.Stacks.make(Blocks.wheat, 1, 0));
		mMappings.put(new ItemStackContainer(Items.wheat, 1, W), UT.Stacks.make(Blocks.wheat, 1, 7));
		mMappings.put(new ItemStackContainer(Items.carrot, 1, W), UT.Stacks.make(Blocks.carrots, 1, 7));
		mMappings.put(new ItemStackContainer(Items.poisonous_potato, 1, W), UT.Stacks.make(Blocks.potatoes, 1, 0));
		mMappings.put(new ItemStackContainer(Items.potato, 1, W), UT.Stacks.make(Blocks.potatoes, 1, 7));
		mMappings.put(new ItemStackContainer(Items.melon_seeds, 1, W), UT.Stacks.make(Blocks.melon_stem, 1, 0));
		mMappings.put(new ItemStackContainer(Items.melon, 1, W), UT.Stacks.make(Blocks.melon_stem, 1, 7));
		mMappings.put(new ItemStackContainer(Items.pumpkin_seeds, 1, W), UT.Stacks.make(Blocks.pumpkin_stem, 1, 7));
		mMappings.put(new ItemStackContainer(Items.dye, 1, 3), UT.Stacks.make(Blocks.cocoa, 1, 8));
		mMappings.put(new ItemStackContainer(Items.string, 1, W), UT.Stacks.make(Blocks.web, 1, 0));
		mMappings.put(new ItemStackContainer(Items.nether_wart, 1, W), UT.Stacks.make(Blocks.nether_wart, 1, 3));
		mMappings.put(new ItemStackContainer(Items.comparator, 1, W), UT.Stacks.make(Blocks.powered_comparator, 1, 0));
		mMappings.put(new ItemStackContainer(Items.repeater, 1, W), UT.Stacks.make(Blocks.powered_repeater, 1, 0));
		mMappings.put(new ItemStackContainer(Items.bed, 1, W), UT.Stacks.make(Blocks.bed, 1, 0));
		mMappings.put(new ItemStackContainer(Items.iron_door, 1, W), UT.Stacks.make(Blocks.iron_door, 1, 0));
		mMappings.put(new ItemStackContainer(Items.wooden_door, 1, W), UT.Stacks.make(Blocks.wooden_door, 1, 0));
		mMappings.put(new ItemStackContainer(Items.ender_pearl, 1, W), UT.Stacks.make(Blocks.portal, 1, 0));
		mMappings.put(new ItemStackContainer(Items.ender_eye, 1, W), UT.Stacks.make(Blocks.end_portal_frame, 1, 0));
		mMappings.put(new ItemStackContainer(Items.water_bucket, 1, W), UT.Stacks.make(Blocks.water, 1, 0));
		mMappings.put(new ItemStackContainer(Items.lava_bucket, 1, W), UT.Stacks.make(Blocks.lava, 1, 0));
		mMappings.put(new ItemStackContainer(Items.cauldron, 1, W), UT.Stacks.make(Blocks.cauldron, 1, 0));
		mMappings.put(new ItemStackContainer(Items.brewing_stand, 1, W), UT.Stacks.make(Blocks.brewing_stand, 1, 0));
		mMappings.put(new ItemStackContainer(Items.flower_pot, 1, W), UT.Stacks.make(Blocks.flower_pot, 1, 0));
	}
	
	public final ItemStackMap<ItemStackContainer, ItemStack> mMappings = new ItemStackMap<ItemStackContainer, ItemStack>();
	
	@Override
	public Recipe findRecipe(IHasWorldAndCoords aTileEntity, Recipe aRecipe, boolean aNotUnificated, long aSize, ItemStack aSpecialSlot, FluidStack[] aFluids, ItemStack... aInputs) {
		Recipe rRecipe = super.findRecipe(aTileEntity, aRecipe, aNotUnificated, aSize, aSpecialSlot, aFluids, aInputs);
		if (aInputs == null || aInputs.length < 2 || aInputs[0] == null || aInputs[1] == null || GAPI_POST.mFinishedServerStarted <= 0) return rRecipe;
		if (rRecipe == null) {
			ItemStack tUSB = null, tScanned = null;
			for (ItemStack aInput : aInputs) if (UT.Stacks.valid(aInput)) {
				if (UT.Stacks.invalid(tUSB) && OM.is_(OD_USB_STICKS[1], aInput)) tUSB = aInput; else tScanned = aInput;
				if (UT.Stacks.valid(tUSB) && UT.Stacks.valid(tScanned)) {
					assert tScanned != null; // just to make eclipse shut the fuck up
					if (IL.Paper_Blueprint_Used.equal(tScanned, F, T)) {
						ItemStack[] tCraftingRecipe = UT.NBT.getBlueprintCrafting(tScanned);
						if (tCraftingRecipe != ZL_ITEMSTACK) {
							rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, tScanned), UT.Stacks.amount(1, tUSB)}, new ItemStack[] {UT.Stacks.amount(1, tUSB), UT.Stacks.amount(1, tScanned)}, null, null, null, null, 64, 16, 0);
							rRecipe.mCanBeBuffered = F;
							if (!rRecipe.mOutputs[0].hasTagCompound()) rRecipe.mOutputs[0].setTagCompound(new NBTTagCompound());
							rRecipe.mOutputs[0].getTagCompound().setTag(NBT_USB_DATA, UT.NBT.setBlueprintCrafting(new NBTTagCompound(), tCraftingRecipe));
							rRecipe.mOutputs[0].getTagCompound().setByte(NBT_USB_TIER, (byte)1);
							return rRecipe;
						}
						return rRecipe;
					}
					if (OM.is_("gt:canvas", tScanned)) {
						if (tScanned.hasTagCompound() && tScanned.getTagCompound().hasKey(NBT_CANVAS_BLOCK)) {
							rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, tScanned), UT.Stacks.amount(1, tUSB)}, new ItemStack[] {UT.Stacks.amount(1, tUSB), UT.Stacks.amount(1, tScanned)}, null, null, null, null, 64, 16, 0);
							rRecipe.mCanBeBuffered = F;
							if (!rRecipe.mOutputs[0].hasTagCompound()) rRecipe.mOutputs[0].setTagCompound(new NBTTagCompound());
							NBTTagCompound tNBT = new NBTTagCompound();
							tNBT.setInteger(NBT_CANVAS_BLOCK, tScanned.getTagCompound().getInteger(NBT_CANVAS_BLOCK));
							tNBT.setInteger(NBT_CANVAS_META, tScanned.getTagCompound().getInteger(NBT_CANVAS_META));
							rRecipe.mOutputs[0].getTagCompound().setTag(NBT_USB_DATA, tNBT);
							rRecipe.mOutputs[0].getTagCompound().setByte(NBT_USB_TIER, (byte)1);
							return rRecipe;
						}
						return rRecipe;
					}
					if ((tScanned.getItem() == ItemsGT.sMultiItemBooks || OM.is_("bookWritten", tScanned) || IL.Paper_Printed_Pages.equal(tScanned, F, T) || IL.Paper_Printed_Pages_Many.equal(tScanned, F, T)) && UT.Code.stringValid(UT.NBT.getBookTitle(tScanned))) {
						rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, tScanned), UT.Stacks.amount(1, tUSB)}, new ItemStack[] {UT.Stacks.amount(1, tUSB), UT.Stacks.amount(1, tScanned)}, null, null, null, null, 512, 16, 0);
						rRecipe.mCanBeBuffered = F;
						if (!rRecipe.mOutputs[0].hasTagCompound()) rRecipe.mOutputs[0].setTagCompound(new NBTTagCompound());
						rRecipe.mOutputs[0].getTagCompound().setTag(NBT_USB_DATA, tScanned.getTagCompound().copy());
						rRecipe.mOutputs[0].getTagCompound().setByte(NBT_USB_TIER, (byte)1);
						return rRecipe;
					}
					if (tScanned.getItem() == Items.filled_map) {
						rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, tScanned), UT.Stacks.amount(1, tUSB)}, new ItemStack[] {UT.Stacks.amount(1, tUSB), UT.Stacks.amount(1, tScanned)}, null, null, null, null, 64, 16, 0);
						rRecipe.mCanBeBuffered = F;
						if (!rRecipe.mOutputs[0].hasTagCompound()) rRecipe.mOutputs[0].setTagCompound(new NBTTagCompound());
						rRecipe.mOutputs[0].getTagCompound().setTag(NBT_USB_DATA, UT.NBT.setMapID(new NBTTagCompound(), UT.Stacks.meta(tScanned)));
						rRecipe.mOutputs[0].getTagCompound().setByte(NBT_USB_TIER, (byte)1);
						return rRecipe;
					}
					ItemStack tMapping = mMappings.get(tScanned.getItem(), UT.Stacks.meta(tScanned));
					if (tMapping == null) tMapping = mMappings.get(tScanned.getItem(), W);
					Block tBlock = UT.Stacks.block_(tMapping==null?tScanned:tMapping);
					if (tBlock != null && tBlock != NB) {
						rRecipe = new Recipe(F, F, new ItemStack[] {UT.Stacks.amount(1, tScanned), UT.Stacks.amount(1, tUSB)}, new ItemStack[] {UT.Stacks.amount(1, tUSB), UT.Stacks.amount(1, tScanned)}, null, null, null, null, 512, 16, 0);
						rRecipe.mCanBeBuffered = F;
						if (!rRecipe.mOutputs[0].hasTagCompound()) rRecipe.mOutputs[0].setTagCompound(new NBTTagCompound());
						NBTTagCompound tNBT = new NBTTagCompound();
						tNBT.setInteger(NBT_CANVAS_BLOCK, Block.getIdFromBlock(tBlock));
						tNBT.setInteger(NBT_CANVAS_META, UT.Stacks.meta(tScanned));
						rRecipe.mOutputs[0].getTagCompound().setTag(NBT_USB_DATA, tNBT);
						rRecipe.mOutputs[0].getTagCompound().setByte(NBT_USB_TIER, (byte)1);
						return rRecipe;
					}
					return rRecipe;
				}
			}
		}
		return rRecipe;
	}
	
	@Override public boolean containsInput(ItemStack aStack, IHasWorldAndCoords aTileEntity, ItemStack aSpecialSlot) {return T;}
}
